<h2 class="title"><a href="#">Descripciones por habitación</a></h2>
<?php
include_once './lib/funciones.php';
$id_hotel = $mysqli->real_escape_string($_GET['id_hotel']);
$id_habitacion = $mysqli->real_escape_string($_GET['id_habitacion']);
$comando = $mysqli->real_escape_string($_GET['comando']);

$hotel = get_row($mysqli, 'hoteles', 'id_hotel', $id_hotel);
if ($hotel == null) {
  echo '<div class="alert alert-danger">No se ha encontrado el hotel.</div>';
  exit;
}

$habitacion = get_row($mysqli, 'habitaciones', 'id_habitacion', $id_habitacion);
if ($habitacion == null) {
  echo '<div class="alert alert-danger">No se ha encontrado la habitación.</div>';
  exit;
}

if ($comando === "insertar") {
}

if ($comando === "update") {
  $query = "SELECT * FROM `descripcion_habitacion` WHERE `id_habitacion` = ? AND `id_hotel` = ?";
  $stmt = $mysqli->prepare($query);
  $stmt->bind_param("ii", $id_habitacion, $id_hotel);
  $stmt->execute();
  $result = $stmt->get_result();
  if ($result->num_rows > 0) {
    $descripcion = $result->fetch_assoc();
    $id_descripcion_habitacion = $descripcion['id'];
  } else {
    echo '<div class="alert alert-danger">No se ha encontrado la descripción de la habitación.</div>';
    exit;
  }
}
?>
<br>
<h3>Hotel: <?= $hotel["hotel"] ?></h3>
<h3>Habitación: <?= $habitacion["habitacion"] ?></h3>
<form action="guarda_descripcion_habitacion.php" method="post">
  <input type="hidden" name="id_hotel" value="<?= $id_hotel ?>">
  <input type="hidden" name="id_habitacion" value="<?= $id_habitacion ?>">
  <input type="hidden" name="id_descripcion_habitacion" value="<?= isset($id_descripcion_habitacion) ? $id_descripcion_habitacion : '' ?>">
  <input type="hidden" name="comando" value="<?= $comando ?>">
  <div class="form-group">
    <label for="descripcion">Descripción:</label>
    <textarea class="form-control" id="descripcion" name="descripcion" rows="5"><?= isset($descripcion) ? $descripcion["descripcion"] : '' ?></textarea>
  </div>
  <div class="form-group">
    <label for="descripcion_en">Descripción (Inglés):</label>
    <textarea class="form-control" id="descripcion_en" name="descripcion_en" rows="5"><?= isset($descripcion) ? $descripcion["descripcion_en"] : '' ?></textarea>
  </div>
  <button type="submit" class="material">Guardar</button>
</form>
<br>
<!-- Galería -->
<h2 id="galeria" class="title"><a href="#">Galería</a></h2>
<table class="galeria">
  <?php
  include_once './lib/funciones.php';
  $path = "img/galerias/$id_hotel/$id_habitacion";
  if (is_dir($path)) {
    $archivos = getDirectoryList($path);
  }
  if ($archivos != "") {
    foreach ($archivos as $archivo) { ?>
      <tr>
        <td>
          <img src="<?= $path ?>/<?= $archivo ?>" />
        </td>
        <td>
          <a href="borra_galeria_descripcion.php?archivo=<?= $archivo ?>&id_hotel=<?= $id_hotel ?>&id_habitacion=<?= $id_habitacion ?>" class="material">Eliminar</a></p>
        </td>
      </tr>
  <? }
  } ?>
</table>
<p class="byline"></p>
<form action="agregar_galeria_descripcion.php" method="post" enctype="multipart/form-data">
  <input type="hidden" name="id_hotel" id="id_hotel" value="<?= $id_hotel ?>">
  <input type="hidden" name="id_habitacion" id="id_habitacion" value="<?= $id_habitacion ?>">
  <input type="file" name="archivo[]" accept="image/jpeg" id="file" multiple="multiple">
  <input type="hidden" name="MAX_FILE_SIZE" value="4096000" />
  <br>
  <button type="submit" class="material">Agregar</button>
</form>
<br>
<br>
<a href="index.php?modulo=backoffice&opcion=hotel&id_hotel=<?= $id_hotel ?>#descripciones" class="material">Regresar</a>