<?php
include "./lib/funciones.php";
$id_hotel = $mysqli->real_escape_string($_GET['id_hotel']);
$id_habitacion = $mysqli->real_escape_string($_GET['id_habitacion']);

/* Se obtiene la información del hotel */
$hotel = get_row($mysqli, "hoteles", "id_hotel", $id_hotel);
/** Se obtiene la información de la habitación */
$habitacion = get_row($mysqli, "habitaciones", "id_habitacion", $id_habitacion);

/** Se obtiene el listado de imágenes en la galería */
$path = "img/galerias/{$id_hotel}/{$id_habitacion}";
if (is_dir($path)) {
  $archivos = getDirectoryList($path);
}


/** Se obtiene la descripción del habitacion */
$query = "SELECT * FROM `descripcion_habitacion` WHERE id_habitacion = ? AND id_hotel = ?";
$stmt = $mysqli->prepare($query);
$stmt->bind_param("ii", $id_habitacion, $id_hotel);
$stmt->execute();
$result = $stmt->get_result();
$descripcion_habitacion = $result->fetch_assoc();
?>

<div class="descripcion">
  <h2><?= $hotel["hotel"] ?></h2>
  <h2><?= $habitacion["habitacion" . $sufijo] ?></h2>
  <p><?= $descripcion_habitacion["descripcion" . $sufijo] ?></p>
</div>

<link rel="stylesheet" type="text/css" href="css/jquery.ad-gallery.css">
<script type="text/javascript" src="js/jquery.ad-gallery.js"></script>
<script type="text/javascript">
  $(function() {
    var galleries = $('.ad-gallery').adGallery({
      slideshow: {
        autostart: true
      }
    });
    //galleries[0].settings.slideshow.autostart=true;
    $('#switch-effect').change(
      function() {
        galleries[0].settings.effect = $(this).val();
        return false;
      }
    );
    $('#toggle-slideshow').click(
      function() {
        galleries[0].slideshow.toggle();
        return false;
      }
    );
    $('#toggle-description').click(
      function() {
        if (!galleries[0].settings.description_wrapper) {
          galleries[0].settings.description_wrapper = $('#descriptions');
        } else {
          galleries[0].settings.description_wrapper = false;
        }
        return false;
      }
    );
  });
</script>

<?php if ($archivos != "") { ?>
  <div id="gallery" class="ad-gallery" style="margin: 0 auto;">
    <div class="ad-image-wrapper">
    </div>
    <div class="ad-controls">
    </div>
    <div class="ad-nav">
      <div class="ad-thumbs">
        <ul class="ad-thumb-list">
          <? foreach ($archivos as $archivo) { ?>
            <li>
              <a href="<?= $path ?>/<?= $archivo ?>">
                <img src="<?= $path ?>/<?= $archivo ?>" width="155px" />
              </a>
            </li>
          <? } ?>
        </ul>
      </div> <!-- .ad-thumbs -->
    </div> <!-- .ad-nav -->
  </div> <!-- #gallery -->
<?php } ?>
<!-- end if galeria -->