<?php
require 'vendor/autoload.php';

use PhpOffice\PhpSpreadsheet\Spreadsheet;
use PhpOffice\PhpSpreadsheet\Writer\Xlsx;

$spreadsheet = new Spreadsheet();
$activeWorksheet = $spreadsheet->getActiveSheet();

set_time_limit(600);
session_start();
$marca  = date("(dmy His)");
$nombre = "Rooming$marca.xlsx";
require_once('lib/comun.php');
$_REQUEST["download"] = "yes";
$q = "select DATEDIFF(max(fecha_salida) + INTERVAL 1 DAY,min(fecha_entrada) - INTERVAL 1 DAY) as cuantas,min(fecha_entrada) - INTERVAL 1 DAY as inicio,max(fecha_salida) + INTERVAL 1 DAY  as fin from reservaciones
		where fecha_entrada<>'0000-00-00 00:00:00' and  fecha_salida<>'0000-00-00 00:00:00'";
$d = $mysqli->query($q);
$r = $d->fetch_array();
$cuantas = $r["cuantas"];
$inicio = $r["inicio"];
$fin = $r["fin"];
$ordenar = "fecha_entrada";
if ($_GET["ordenar"]) {
  $ordenar = $_GET["ordenar"];
}
$hotel = "";
if ($_GET["id_hotel"]) {
  $hotel = "and reservaciones.id_hotel=" . $_GET["id_hotel"];
}
if ($_GET["empresa"]) {
  $empresa = $_GET["empresa"];
  echo $empresa;
  $empresa = "and reservaciones.empresa='$empresa'";
}
$SQL = "SELECT id_reservacion AS Clave, email, empresa AS Empresa, concat(paterno,' ',materno,' ',nombre) AS Nombre,acompanante AS 'Acompañante',hotel AS Hotel,habitacion AS Habitación,ROUND(precio/1.16,2) AS Costo,fecha_entrada AS Llegada,DATE_ADD(fecha_salida, INTERVAL 1 DAY) AS Salida,DATEDIFF(DATE_ADD(fecha_salida, INTERVAL 1 DAY),fecha_entrada) AS Noches,(DATEDIFF(DATE_ADD(fecha_salida, INTERVAL 1 DAY),fecha_entrada)*ROUND(precio/1.16,2)) AS Importe,nocamas AS Camas,requerimientos AS Observaciones, fecha_salida AS SalidaO
			FROM reservaciones
			LEFT JOIN hoteles ON hoteles.id_hotel=reservaciones.id_hotel
			LEFT JOIN habitaciones ON habitaciones.id_habitacion=reservaciones.id_habitacion
			LEFT JOIN precios ON precios.id_hotel=reservaciones.id_hotel AND precios.id_habitacion=reservaciones.id_habitacion
			WHERE status='Confirmada' $hotel $empresa
			ORDER BY $ordenar";
$result = $mysqli->query($SQL) or die("Couldn t execute query. = " . $SQL);

if ($result->num_rows > 0) {
  $gotHeaders = false;
  $i = 1;
  while ($row = $result->fetch_assoc()) {
    $salida0 = $row["SalidaO"];
    $llegada0 = $row["Llegada"];
    array_pop($row);
    if (!$gotHeaders) {
      $headers = array_keys($row);
      /** Agrega las fechas disponibles */
      for ($j = 1; $j < $cuantas; $j++) {
        $date = strtotime("+" . $j . " days", strtotime($inicio));
        $date =  date("d/m/Y", $date);
        array_splice($headers, -1, 0, $date);
      }
      $activeWorksheet->fromArray($headers, NULL, 'A' . $i);
      $gotHeaders = true;
      $i++;
    }
    /** Formatea las fechas */
    $row["Llegada"] = date('d/m/Y', strtotime($row["Llegada"]));
    $row["Salida"] = date('d/m/Y', strtotime($row["Salida"]));
    /** Inserta los días correspondientes */
    for ($j = 1; $j < $cuantas; $j++) {
      $date = strtotime("+" . $j . " days", strtotime($inicio));
      $date =  date("Y-m-d", $date);
      $today = strtotime($date);
      $fromdate = strtotime($llegada0);
      $todate = strtotime($salida0);
      array_splice($row, -1, 0, ($today >= $fromdate && $today <= $todate) ? $row["Habitación"] : '');
    }
    $activeWorksheet->fromArray($row, NULL, 'A' . $i);
    $i++;
  }
  /** Ajuste autático del ancho de las columnas */
  foreach (range('A', $spreadsheet->getActiveSheet()->getHighestDataColumn()) as $columnID) {
    $spreadsheet->getActiveSheet()->getColumnDimension($columnID)->setAutoSize(true);
  }
  $writer = new Xlsx($spreadsheet);
  /** Forzar la descarga del archivo */
  header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
  header('Content-Disposition: attachment;filename="' . $nombre . '"');
  $writer->save('php://output');
}
